"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var getRouteAction = function getRouteAction(route, state) {
  return route.match(state) ? null : route.action();
};

var getParamActions = function getParamActions(route, values, state) {
  return Object.values(route.params).filter(function (_ref) {
    var key = _ref.key,
        selector = _ref.selector,
        stringify = _ref.stringify,
        notSetValue = _ref.notSetValue;
    var specValue = values[key];
    var stateValue = selector(state);
    var specValueSet = specValue !== notSetValue;
    var stateValueSet = stateValue !== notSetValue;
    return specValueSet && stateValueSet ? stringify(specValue) !== stringify(stateValue) : specValueSet !== stateValueSet;
  }).map(function (_ref2) {
    var key = _ref2.key,
        action = _ref2.action;
    return action(values[key]);
  });
};

var _default = function _default(routes, state, spec) {
  var routeAction = getRouteAction(spec.route, state);
  var paramActions = getParamActions(spec.route, spec.params, state);
  return routeAction ? [].concat(_toConsumableArray(paramActions), [routeAction]) : paramActions;
};

exports.default = _default;