"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("./utils");

var getRouteFromState = function getRouteFromState(routes, state) {
  return routes.find(function (route) {
    return route.match(state);
  });
};

var getStateValues = function getStateValues(route, state) {
  return Object.values(route.params).map(function (_ref) {
    var key = _ref.key,
        selector = _ref.selector;
    return [key, selector(state)];
  }).reduce(_utils.createObject, {});
};

var _default = function _default(routes, state) {
  var route = getRouteFromState(routes, state);
  var redirected = (0, _utils.redirect)(routes, route);

  if (redirected !== undefined) {
    var stateValues = getStateValues(redirected, state);
    return (0, _utils.createSpec)(redirected, stateValues);
  } else {
    return undefined;
  }
};

exports.default = _default;